# Designed December 2010 by ChrisP

# Permission to use this software for any purpose and without fee is hereby granted
# Distribution of this software for commercial purpose is forbidden:

# THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR
# IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
#-----------------------------------------------------------------------------
# Name            :  ChrisP_Repair_AddFace_DWG
# Original Date   :  21 December 2010 version 0.0
# Thanks          :  Thanks to Fab for the idea	
# Type            :  Plugin testing for SU6, SU7, SU8 
# Description     :  Repair IMPORT DWG, reconstruct intersect, delete short line, extend line, add faces
# Usage           :  By ToolBar
# Version         :  0.2.0 Beta
#2014年至2015年... dota_修复使用W+后线跑到组外的BUG，修改W-的单位为mm，修复插件支持到SU2015，显示插件菜单到Plugins下（方便设置快捷键）。

require "sketchup.rb"
#require "jjProgressBar_MsAPI.rb"

class Sketchup::ComponentInstance
    def entities
        self.definition.entities
    end
end

class Create_Faces_find

    def activate() 
        @ip = Sketchup::InputPoint.new
        @iptemp = Sketchup::InputPoint.new
        @displayed = false
        @curseur = 1
	cursors
	onSetCursor
    end
    def onSetCursor
          UI::set_cursor(@curseur1) if @curseur == 1
          UI::set_cursor(@curseur11) if @curseur == 11
          UI::set_cursor(@curseur111) if @curseur == 111
          Sketchup.active_model.active_view.invalidate  
    end
    
    def cursors
	path1 = File.join(File.dirname(__FILE__),  "ChrisP_Repair_AddFace_DWG", "cursor1.png")
	path11 = File.join(File.dirname(__FILE__),  "ChrisP_Repair_AddFace_DWG", "cursor11.png")
	path111 = File.join(File.dirname(__FILE__),  "ChrisP_Repair_AddFace_DWG", "cursor111.png")
        @curseur1 = UI::create_cursor(path1, 0, 0)
        @curseur11 = UI::create_cursor(path11, 0, 0)
        @curseur111 = UI::create_cursor(path111, 0, 0)
end
    def onMouseMove(flags, x, y, view)
        Sketchup::set_status_text("#{x}, #{y}", SB_VCB_VALUE)
        
        @iptemp.pick view, x, y
        if( @iptemp.valid? )
            changed = @iptemp != @ip
            @ip.copy! @iptemp
            pos = @ip.position;
            
            msg = @ip.tooltip
            if( msg.length > 0 )
                msg << " "
            end
    
            
            if( @ip.vertex == nil )
                if(@ip.edge)
                    @curseur = 11
                    onSetCursor
                    if( @ip.depth > 0 )
                        length = @ip.edge.length(@ip.transformation)
                    else
                        length = @ip.edge.length
                    end

                    msg << "\n  单击封闭相邻面；双击删除" + "\n  长度" + "：" + length.to_s + "\n"
                 elsif(@ip.face)
                    @curseur = 111
                    onSetCursor 
                    area = '%.2f' % @ip.face.area
                    msg << "\n  单击翻面；双击删除" + "\n  面积" + "：" + area + "\n"
                 else
                    @curseur = 1
                    onSetCursor
                 end
            end
    
            msg2 = msg.gsub(/\n/,' ')
            Sketchup::set_status_text msg2
            
            view.tooltip = msg
            
            if( changed and(@ip.display? or @displayed) )
                
                view.invalidate
            end
        end
        
    end  
    def onLBDown(flags, x, y, view)
        UI.stop_timer @id
        model = Sketchup.active_model
        selection = model.selection
        entities = model.entities
        selection.clear
        model.start_operation "添加面"
        edge = nil
        face = nil
        ph = view.pick_helper
        ph.do_pick x,y
        leaf = ph.leaf_at 0
        
            if(leaf.is_a? Sketchup::Edge)
            	edge = leaf
            elsif(leaf.is_a? Sketchup::Face)
            	face = leaf
            else
            	return
            end
            
        if(edge)
                par = edge.parent 
                edges = edge.all_connected
                edges.collect! {|ed| ed = ed if(ed.is_a? Sketchup::Edge)}
                edges.compact!
                tab_points=[]
                edges.each {|ed|
                if(ed.start.edges.length<2 || ed.end.edges.length<2)
                    tab_points.push Geom::Point3d.new ed.start
                    tab_points.push Geom::Point3d.new ed.end
                    entities.erase_entities(ed)
                end 
                }
	        edge.find_faces
	        long = (tab_points.length / 2) - 1
      	            for x in (0..long) do
      	                pt= x*2
            		par.entities.add_line(tab_points[pt],tab_points[pt+1])             		
        	    end
        end  
        face.reverse! if(face)
        Sketchup.active_model.commit_operation
    end   
    def onLButtonDown(flags, x, y, view)
        call_method(flags, x, y, view)
    end
    def onLButtonDoubleClick(flags, x, y, view)
        UI.stop_timer @id
        Sketchup.active_model.selection.clear
        Sketchup.active_model.start_operation"添加面"
        ph = view.pick_helper
        ph.do_pick x,y
        best = ph.leaf_at 0
        Sketchup.active_model.entities.erase_entities best if(best.is_a? Sketchup::Face)
        Sketchup.active_model.entities.erase_entities best if(best.is_a? Sketchup::Edge)        
        Sketchup.active_model.commit_operation
    end     
    def call_method(flags, x, y, view)
            start_time = Time.now
            elapsed_time = 0
          	loop do
                   elapsed_time = Time.now - start_time
                  	if elapsed_time >= 0.20   				###### delay time ######
                                @id = UI.start_timer(0,false){
        			onLBDown(flags, x, y, view)
                    		}                  
                    	break
                  	end
          	end    
    end          
  
end

class Create_Faces_connected

    def activate() 
        @ip = Sketchup::InputPoint.new
        @iptemp = Sketchup::InputPoint.new
        @displayed = false
	@curseur = 2
	cursors
	onSetCursor
    end
    def onSetCursor
          UI::set_cursor(@curseur2) if @curseur == 2
          UI::set_cursor(@curseur22) if @curseur == 22
          UI::set_cursor(@curseur222) if @curseur == 222
          Sketchup.active_model.active_view.invalidate  
    end
    
    def cursors
	path2 = File.join(File.dirname(__FILE__),  "ChrisP_Repair_AddFace_DWG", "cursor2.png")
	path22 = File.join(File.dirname(__FILE__),  "ChrisP_Repair_AddFace_DWG", "cursor22.png")
	path222 = File.join(File.dirname(__FILE__),  "ChrisP_Repair_AddFace_DWG", "cursor222.png")
        @curseur2 = UI::create_cursor(path2, 0, 0)
        @curseur22 = UI::create_cursor(path22, 0, 0)
        @curseur222 = UI::create_cursor(path222, 0, 0)
    end        

    def onLBDown(flags, x, y, view)
        UI.stop_timer @id
        model = Sketchup.active_model
        entities = model.entities
        selection = model.selection
        selection.clear
        model.start_operation "添加面"
        edge = nil
        face = nil
        ph = view.pick_helper
        ph.do_pick x,y
        leaf = ph.leaf_at 0
        
            if(leaf.is_a? Sketchup::Edge)
            	edge = leaf
            elsif(leaf.is_a? Sketchup::Face)
            	face = leaf
            else
            	return
            end
            
  	   if(edge)
                par = edge.parent
                edges0 = edge.all_connected
                edges0.collect! {|ed| ed = ed if(ed.is_a? Sketchup::Edge)}
                edges0.compact!
                tab_points=[]
                edges0.each {|ed|                
	                if(ed.start.edges.length<2 || ed.end.edges.length<2)
	                    tab_points.push Geom::Point3d.new ed.start
	                    tab_points.push Geom::Point3d.new ed.end
	                    entities.erase_entities(ed)
	                end
                	}
                fen = JJ_ProgressBar.new("进度条", nil)
                pb1 = fen.add_PB("Recherche Globale des faces")
                pb2 = fen.add_PB("Methode find_faces")
                @x=0
                edges0.each {|ed|
                        fen.set_Pos pb1, @x                
	                edges0.collect! {|ed| ed = ed if((ed.is_a? Sketchup::Edge) && ed.deleted? == false)}
	                edges0.compact!                
	                begin
	                selection.add par.entities.add_face(edges0)
	                rescue
	                @y=0
	                edges0.each {|x|
                        fen.set_Pos pb2, @y
	                face1 = x.find_faces if x.deleted? == false                
	                edges0.delete x if face1 >0
	                @y = @y + 1
	                }
	                end
	                @x = @x + 1 
                	}
                fen.close pb1	
                fen = fen.kill
              	long = (tab_points.length / 2) - 1
            	            for x in (0..long) do
            	                pt= x*2
                  		par.entities.add_line(tab_points[pt],tab_points[pt+1])             		
              	    	end 	            
           end
           
       face.reverse! if face
       model.commit_operation
   end
   def onLButtonDown(flags, x, y, view)
       call_method(flags, x, y, view)
   end 
   def onMouseMove(flags, x, y, view)
        Sketchup::set_status_text("#{x}, #{y}", SB_VCB_VALUE)
        
        @iptemp.pick view, x, y
        if( @iptemp.valid? )
            changed = @iptemp != @ip
            @ip.copy! @iptemp
            pos = @ip.position;
            
            msg = @ip.tooltip
            if( msg.length > 0 )
                msg << " "
            end
    
            
            if( @ip.vertex == nil )
                if(@ip.edge)
                    @curseur = 22
                    onSetCursor
                    if( @ip.depth > 0 )
                        length = @ip.edge.length(@ip.transformation)
                    else
                        length = @ip.edge.length
                    end

                    msg << "\n  单击修剪；双击删除" + "\n  长度 " + "：" + length.to_s + "\n"
                 elsif(@ip.face)
                    @curseur = 222
                    onSetCursor
                    area = '%.2f' % @ip.face.area
                    msg << "\n  单击翻面；双击删除" + "\n  面积 " + "：" + area + "\n"
                 else
                    @curseur = 2
                    onSetCursor
                 end
            end
    
            msg2 = msg.gsub(/\n/,' ')
            Sketchup::set_status_text msg2
            
            view.tooltip = msg
            
            if( changed and(@ip.display? or @displayed) )
                view.invalidate
            end
        end
        
    end  
   def onLButtonDoubleClick(flags, x, y, view)
        UI.stop_timer @id
        Sketchup.active_model.selection.clear
        Sketchup.active_model.start_operation"添加面"
        ph = view.pick_helper
        ph.do_pick x,y
        best = ph.leaf_at 0
        Sketchup.active_model.entities.erase_entities best if(best.is_a? Sketchup::Face)
        Sketchup.active_model.entities.erase_entities best if(best.is_a? Sketchup::Edge)        
        Sketchup.active_model.commit_operation
   end              
   def call_method(flags, x, y, view)
        start_time = Time.now
        elapsed_time = 0
      	loop do
               elapsed_time = Time.now - start_time
              	if elapsed_time >= 0.20   				###### delay time ######
                            @id = UI.start_timer(0,false){
    				onLBDown(flags, x, y, view)
                		}                  
                	break
              	end
      	end    
   end    

end
    
module Repair_DWG

    def self.explod_recons
    	Sketchup.send_action "selectSelectionTool:"
    	model = Sketchup.active_model
    	entities = model.entities
    	selection = model.selection
    	definitions = model.definitions
    	model.start_operation "重建DWG"
    	definitions.purge_unused
    	tab_def = []
    	tab_edge = []
    	
    	    if selection.empty?
	        oui_non = UI.messagebox "未选择组件，是否应有到所有所有？", MB_YESNO 
	      	if(oui_non == 6)
	      		definitions.each {|x| tab_def.push x}
	       	else
	       		return 
	       	end
	      
	    else
	       		selection.each { |sel| tab_def.push sel.definition if sel.is_a? Sketchup::ComponentInstance}
	    end
	    
    	        tab_def.each {|defi|
    	        def_sav = defi
    	        nom_def = defi.name
    	        defi.name = ""
    	        des_def = defi.description
    	        tab_inst = []
    	        defi.instances.each {|y| tab_inst.push y}
    	            tab_inst.each {|inst|
    	                nom_inst = inst.name
    	                group_temp = entities.add_group(inst)
    	                inst.explode
    	                comp = group_temp.to_component
    	                comp.name = nom_inst
    	                comp.definition.name = nom_def
    	                comp.definition.description = des_def
    	        } 
    	    }
    	definitions.purge_unused
    	model.commit_operation
    end # fin methode      


    def self.extend_shortline
    	Sketchup.send_action "selectSelectionTool:"
    	model = Sketchup.active_model
    	entities = model.active_entities
    	selection = model.selection
    	definitions = model.definitions
    	materials = model.materials
    	model.start_operation "孤立边线"
    	definitions.purge_unused	
    	tab_def = []
    	tab_ent = []
    	if selection.empty?
	        oui_non = UI.messagebox "未选定元素，是否应用到所有元素？", MB_YESNO 
	      	if(oui_non == 6)
	      	        entities.each {|sel| tab_ent.push sel if(sel.is_a? Sketchup::Edge)}
	      		definitions.each {|sel| tab_def.push sel}
	       	else
	       		return 
	       	end
	      
	else
       		selection.each { |sel| 
       			tab_def.push sel.definition if(sel.is_a? Sketchup::ComponentInstance)
       			tab_ent.push sel if(sel.is_a? Sketchup::Edge)
       			}
	end
	
      	prompts = ["两端延长 % : "] 
      	val_defaut = [10]  
      	results = UI.inputbox prompts, val_defaut,("两端延长调整")
	return if not results
	tolerance = results[0]
	tolerance = tolerance.to_f / 100
	selection.clear    
    	tab_edge=[]
              tab_ent.each {|ents|
                  if(ents.curve == nil)
            		if(ents.start.edges.length<2 || ents.end.edges.length<2)
              			tab_edge.push ents
              		else
              			selection.add ents
              		end
        	      end 
                  if(ents.curve)
            		ents.curve.edges.each {|cu|
                		if(cu.start.edges.length<2 || cu.end.edges.length<2)
                			tab_edge.push cu
                		else
                			selection.add cu
                		end
                		}
                 end
             }
              tab_edge.uniq!
              group = entities.add_group()
          	  tab_edge.each {|edge0|
              ps = edge0.start
              pe  =edge0.end
              long_edge = edge0.length * tolerance
              pt1 = ps.position
              pt2 = pe.position
              new_pt1 = Geom::Point3d.new pt1
              new_pt2 = Geom::Point3d.new pt2
              vect1 = pt1.vector_to pt2
              vect2 = vect1.reverse
              ray1 = model.raytest([pt2, vect1])
              ray2 = model.raytest([pt1, vect2])
              (ray1)? (ray1 = ray1[0]):(ray1 = false) 
              (ray2)? (ray2 = ray2[0]):(ray2 = false) 
              new_pt11 = Geom::Point3d.new ray1 if ray1
              new_pt22 = Geom::Point3d.new ray2 if ray2
              pe.edges.length<2? pe_ed = true : pe_ed =false
              ps.edges.length<2? ps_ed = true : ps_ed =false
              (ray1)?(dist1 = pt2.distance ray1):(dist1 = false) 
              (ray2)?(dist2 = pt1.distance ray2):(dist2 = false)
              (dist1)?(((long_edge>=dist1)?( pe_dist = true):(pe_dist = false))):(pe_dist = false)
              (dist2)?(((long_edge>=dist2)?(ps_dist = true):(ps_dist = false))):(ps_dist = false)
              
              	if ps_ed == false && pe_ed == false
              		next
              	elsif ps_ed && pe_ed && pe_dist && ps_dist
              		entities.erase_entities edge0
              	        line=group.entities.add_line new_pt11, new_pt22
              	        selection.add line
              	        line.material = "red"				# a supprimer
              	elsif ps_ed ==  false && pe_ed && pe_dist
              		entities.erase_entities edge0
              	        line=group.entities.add_line new_pt1, new_pt11
              	        selection.add line
              	        line.material = "red"				# a supprimer
              	elsif pe_ed ==  false && ps_ed && ps_dist
              		entities.erase_entities edge0
              	        line=group.entities.add_line new_pt2, new_pt22
              	        selection.add line              	        
              	        line.material = "red"				# a supprimer
              	else
		
        		vect1.length = vect1.length*tolerance
                        pt11 =  pt2.offset vect1
                        new_pt11 = Geom::Point3d.new pt11
                        vect2.length = vect2.length*tolerance
        	        pt00 = pt1.offset vect2
        	        new_pt00 = Geom::Point3d.new pt00
        	        
        		entities.erase_entities edge0              	
                      	
                      		if ! ps_ed
                      	        	line=group.entities.add_line new_pt1, new_pt11
                      	        	selection.add line
                      	        	line.material = "red"				# a supprimer	                        				                		
                      		elsif ! pe_ed
                      	        	line=group.entities.add_line new_pt00, new_pt2
              	        		selection.add line
                      	        	line.material = "red"				# a supprimer            		
                      		elsif ps_ed && pe_ed
                      	        	line=group.entities.add_line new_pt00, new_pt11
                      	                selection.add line
                      	        	line.material = "red"				# a supprimer	               		              		
                      		end
              		      		
              	end
          }
          group.explode
          selection.clear    
          #tab_def = []
    	  tab_def.each {|x| x.instances.each { |xx| xx.make_unique}}
    	        tab_def.each {|defi|
            	        def_sav = defi
            	        nom_def = defi.name
            	        defi.name = ""
            	        des_def = defi.description
            	            defi.instances.each {|inst|
          	                tab_edge = []
          	                nom_inst = inst.name
          	                inst_expl = inst.explode
                                    inst_expl.each {|ents| 
                      			if (ents.is_a? Sketchup::Edge) && ents.curve == nil
            
            					if ents.start.edges.length<2 || ents.end.edges.length<2
            	                  			tab_edge.push ents
            	                  		else
            	                  			selection.add ents
            	                  		end
            
            	                  	end
                              	    }              
                                     inst_expl.each {|ents|
                      			if (ents.is_a? Sketchup::Edge) && ents.curve
                				ents.curve.edges.each {|cu|
                					if cu.start.edges.length<2 || cu.end.edges.length<2
                						tab_edge.push cu
                					else
                						selection.add cu
                					end
                    				}
                     			end
                                    }	                                     
                                tab_edge.uniq!
                                group = entities.add_group()
                                    tab_edge.each {|edge0|
                                        ps = edge0.start
                                        pe  =edge0.end
                                        long_edge = edge0.length
                                        pt1 = ps.position
                                        pt2 = pe.position
                                        new_pt1 = Geom::Point3d.new pt1
                                        new_pt2 = Geom::Point3d.new pt2
                                        vect1 = pt1.vector_to pt2
                                        vect2 = vect1.reverse
                                        ray1 = model.raytest([pt2, vect1])
                                        ray2 = model.raytest([pt1, vect2])
                                        (ray1)? (ray1 = ray1[0]):(ray1 = false) 
                                        (ray2)? (ray2 = ray2[0]):(ray2 = false) 
                                        new_pt11 = Geom::Point3d.new ray1 if ray1
                                        new_pt22 = Geom::Point3d.new ray2 if ray2
                                        pe.edges.length<2? pe_ed = true : pe_ed =false
                                        ps.edges.length<2? ps_ed = true : ps_ed =false
                                        (ray1)?(dist1 = pt2.distance ray1):(dist1 = false) 
                                        (ray2)?(dist2 = pt1.distance ray2):(dist2 = false)
                                        (dist1)?(((long_edge>dist1)?( pe_dist = true):(pe_dist = false))):(pe_dist = false)
                                        (dist2)?(((long_edge>dist2)?(ps_dist = true):(ps_dist = false))):(ps_dist = false)
                                        
                                        if ps_ed == false && pe_ed == false
                                    		selection.add edge0
                                    		next
                                    	elsif ps_ed && pe_ed && pe_dist && ps_dist
                                    		entities.erase_entities edge0
                                    	        new_edge = entities.add_line(new_pt11,new_pt22)
                                    	        new_edge.material = "red"				# a supprimer       		
                                    	        new_edge.start.edges.each {|x| selection.add x}
                                    	        new_edge.end.edges.each {|x| selection.add x}          	        
                                    	elsif ps_ed ==  false && pe_ed && pe_dist
                                    		entities.erase_entities edge0
                                    	        new_edge = entities.add_line(new_pt1,new_pt11)
                                    	        new_edge.material = "red"				# a supprimer       		
                                    	        new_edge.start.edges.each {|x| selection.add x}
                                    	        new_edge.end.edges.each {|x| selection.add x}   
                                    	elsif pe_ed ==  false && ps_ed && ps_dist
                                    		entities.erase_entities edge0
                                    	        new_edge = entities.add_line(new_pt2,new_pt22)
                                    	        new_edge.material = "red"				# a supprimer       		
                                    	        new_edge.start.edges.each {|x| selection.add x}
                                    	        new_edge.end.edges.each {|x| selection.add x}
                                    	else 
                                    		vect1.length = vect1.length*tolerance
                                                    pt11 =  pt2.offset vect1
                                                    new_pt11 = Geom::Point3d.new pt11
                                                    vect2.length = vect2.length*tolerance
                                    	        pt00 = pt1.offset vect2
                                    	        new_pt00 = Geom::Point3d.new pt00
                                    	        
                                    		entities.erase_entities edge0              	
                                                  	
                                                  		if ! ps_ed
                                                  	        	line=group.entities.add_line new_pt1, new_pt11
                                                  	        	#selection.add line
                                                  	        	line.material = "red"				# a supprimer	                        				                		
                                                  		elsif ! pe_ed
                                                  	        	line=group.entities.add_line new_pt00, new_pt2
                                          	        		#selection.add line
                                                  	        	line.material = "red"				# a supprimer            		
                                                  		elsif ps_ed && pe_ed
                                                  	        	line=group.entities.add_line new_pt00, new_pt11
                                                  	                #selection.add line
                                                  	        	line.material = "red"				# a supprimer	               		              		
                                                  		end              	
                                      	end
                                    } # fin tab_edge.each
                        selection.add group
                        group_temp = entities.add_group(selection)
                        group.explode
                        comp = group_temp.to_component
                        comp.name = nom_inst
                        comp.definition.name = nom_def
                        comp.definition.description = des_def
                                  
            	        } #fin defi.instances.each 
    	    } # fin tab_def.each
    	    
    	definitions.purge_unused
	model.commit_operation
    end # fin metohde

def self.delete_shortline
    	Sketchup.send_action "selectSelectionTool:"
    	model = Sketchup.active_model
    	entities = model.entities
    	selection = model.selection
    	definitions = model.definitions
    	model.start_operation "孤立边线"
    	definitions.purge_unused	
    	tab_def = []
    	tab_ent = []
    	tab_eras = []
    	if selection.empty?
	        oui_non = UI.messagebox "未选定元素，是否应用到所有元素？", MB_YESNO 
	      	if(oui_non == 6)
	      	        entities.each {|sel| tab_ent.push sel if(sel.is_a? Sketchup::Edge)}
	      		definitions.each {|sel| tab_def.push sel}
	       	else
	       		return 
	       	end
	      
	else
       		selection.each { |sel| 
       			tab_def.push sel.definition if(sel.is_a? Sketchup::ComponentInstance)
       			tab_ent.push sel if(sel.is_a? Sketchup::Edge)
       			}
	end
	
      	prompts = ["孤立边线长度范围："] 
      	val_defaut = [20.mm]  
      	results = UI.inputbox prompts, val_defaut,("孤立边线长度范围")
	return if not results
	tolerance = results[0]
    	tab_edge=[]
              tab_ent.each {|ents|
                  if(ents.curve == nil)
            		tab_eras.push(ents) if((ents.start.edges.length<2 || ents.end.edges.length<2) && ents.length <= tolerance)              			 
                  elsif(ents.curve)
            		ents.curve.edges.each {|cu| tab_eras.push(cu) if((cu.start.edges.length<2 || cu.end.edges.length<2) && cu.length <= tolerance)}
                 end
             }
          tab_eras.uniq!
    	  tab_eras.each {|x| entities.erase_entities x}
          
    	    tab_def.each {|x| x.instances.each { |xx| xx.make_unique}}
    	        tab_def.each {|defi|
    	            defi.instances.each {|inst|
    	            	tab_eras = []
                        inst.entities.each {|ents|
              			if((ents.is_a? Sketchup::Edge) && ents.curve == nil)    
    					tab_eras.push ents if((ents.start.edges.length<2 || ents.end.edges.length<2) && ents.length <= tolerance)    
              			elsif (ents.is_a? Sketchup::Edge) && ents.curve
                  			ents.curve.edges.each {|cu| tab_eras.push(cu) if((cu.start.edges.length<2 || cu.end.edges.length<2) && ents.length <= tolerance)}
             			end
                              	}
                          tab_eras.uniq!
      			  tab_eras.each {|x| entities.erase_entities x}
            	    }
            	}    		
	definitions.purge_unused
	model.commit_operation
	
    end # fin metohde
   	
    def self.create_faces
    	Sketchup.send_action "selectSelectionTool:"    
        model = Sketchup.active_model
    	entities = model.entities
    	selection = model.selection
    	definitions = model.definitions
    	model.start_operation "封面"        
    	tab_edge = []
    	tab_inst = []
              	if selection.empty?
        	        oui_non = UI.messagebox "未选定元素，是否应用到所有元素？", MB_YESNO 
        	      	if(oui_non == 6)
        	      	        entities.each {|sel| 
        	      	        tab_edge.push sel if sel.is_a? Sketchup::Edge
        	      	        tab_inst.push sel if sel.is_a? Sketchup::ComponentInstance
        	      	        }
        	       	else
        	       		return 
        	       	end
        	      
        	else
               		selection.each { |sel| 
               			tab_inst.push sel if(sel.is_a? Sketchup::ComponentInstance)
               			tab_edge.push sel if(sel.is_a? Sketchup::Edge)
               			}
        	end
        	
        tab_inst.each {|inst| inst.entities.each {|ents| tab_edge.push ents if(ents.is_a? Sketchup::Edge)}}
        tab_edge.uniq!
	until tab_edge.empty?
		tab_edge.each { |edge|
                par = edge.parent
                edges = edge.all_connected
                edges.collect! {|ed| ed = ed if(ed.is_a? Sketchup::Edge)}
                edges.compact!
                tab_points=[]                
                edges.each {|ed|
                if(ed.start.edges.length<2 || ed.end.edges.length<2)
                    tab_points.push Geom::Point3d.new ed.start
                    tab_points.push Geom::Point3d.new ed.end
                    entities.erase_entities(ed)
                    tab_edge.delete(ed)
                end
                } 
                begin
                selection.add par.entities.add_face edges
                rescue
                edges.collect! {|ed| ed = ed if((ed.is_a? Sketchup::Edge) && ed.deleted? == false)}
                edges.compact!
                edges.each {|x| x.find_faces }
           	end
	        long = (tab_points.length / 2) - 1
      	            for x in (0..long) do
      	                pt= x*2
            		par.entities.add_line(tab_points[pt],tab_points[pt+1])             		
        	    end 
        	edges.each {|ed| tab_edge.delete ed if(ed.is_a? Sketchup::Edge)}
       	            	
        	}
	end

        model.commit_operation
        Sketchup.active_model.select_tool Create_Faces_find.new	    	
    end # fin methode
      
end #fin module      	

unless file_loaded?("ChrisP_Repair_AddFace_DWG.rb")

  toolbar = UI::Toolbar.new("dwg文件修复")
  menu = UI.menu('Plugins').add_submenu("dwg文件修复")
    
  cmd3 = UI::Command.new("dwg文件修复")  { Repair_DWG.explod_recons }
  cmd3.small_icon = File.join(File.dirname(__FILE__), "ChrisP_Repair_AddFace_DWG/", "D_sm.png")
  cmd3.large_icon = File.join(File.dirname(__FILE__), "ChrisP_Repair_AddFace_DWG/", "D_lg.png")
  cmd3.tooltip = "交叉口重建"
  cmd3.menu_text = "交叉口重建"
  toolbar .add_item(cmd3)
  menu.add_item(cmd3)
  toolbar.add_separator
  
  cmd1 = UI::Command.new("dwg文件修复")  { Repair_DWG.extend_shortline }
  cmd1.small_icon = File.join(File.dirname(__FILE__), "ChrisP_Repair_AddFace_DWG/", "W1_sm.png")
  cmd1.large_icon = File.join(File.dirname(__FILE__), "ChrisP_Repair_AddFace_DWG/", "W1_lg.png")
  cmd1.tooltip = "延长孤立边线"
  cmd1.menu_text = "延长孤立边线" 
  toolbar .add_item(cmd1)
  menu.add_item(cmd1)
  toolbar.add_separator

  cmd2 = UI::Command.new("dwg文件修复")  { Repair_DWG.delete_shortline }
  cmd2.small_icon = File.join(File.dirname(__FILE__), "ChrisP_Repair_AddFace_DWG/", "W2_sm.png")
  cmd2.large_icon = File.join(File.dirname(__FILE__), "ChrisP_Repair_AddFace_DWG/", "W2_lg.png")
  cmd2.tooltip = "删除孤立线"
  cmd2.menu_text = "删除孤立线" 
  toolbar .add_item(cmd2)
 menu.add_item(cmd2)
  toolbar.add_separator
  
  cmd8 = UI::Command.new("dwg文件修复")  { Repair_DWG.create_faces }
  cmd8.small_icon = File.join(File.dirname(__FILE__), "ChrisP_Repair_AddFace_DWG/", "G_sm.png")
  cmd8.large_icon = File.join(File.dirname(__FILE__), "ChrisP_Repair_AddFace_DWG/", "G_lg.png")
  cmd8.tooltip = "自动封面"
  cmd8.menu_text = "自动封面"
  toolbar .add_item(cmd8)
  menu.add_item(cmd8)
  toolbar.add_separator
   
  cmd6 = UI::Command.new("dwg文件修复")  { Sketchup.active_model.select_tool Create_Faces_find.new }
  cmd6.small_icon = File.join(File.dirname(__FILE__), "ChrisP_Repair_AddFace_DWG/", "G1_sm.png")
  cmd6.large_icon = File.join(File.dirname(__FILE__), "ChrisP_Repair_AddFace_DWG/", "G1_lg.png")
  cmd6.tooltip = "单击翻面"
  cmd6.menu_text = "单击翻面"
  toolbar.add_item(cmd6)
  menu.add_item(cmd6)
  
  cmd0 = UI::Command.new("dwg文件修复")  { Sketchup.active_model.select_tool Create_Faces_connected.new }
  cmd0.small_icon = File.join(File.dirname(__FILE__), "ChrisP_Repair_AddFace_DWG/", "G2_sm.png")
  cmd0.large_icon = File.join(File.dirname(__FILE__), "ChrisP_Repair_AddFace_DWG/", "G2_lg.png")
  cmd0.tooltip = "修剪边线"
  cmd0.menu_text = "修剪边线"
  toolbar.add_item(cmd0)
  menu.add_item(cmd0)
  
  file_loaded "ChrisP_Repair_AddFace_DWG.rb"
end